Index: lemon/dim2.h
===================================================================
--- lemon/dim2.h	(revision 318)
+++ lemon/dim2.h	(revision 220)
@@ -21,4 +21,5 @@
 
 #include <iostream>
+#include <lemon/core.h>
 
 ///\ingroup misc
@@ -29,5 +30,6 @@
 /// a two dimensional vector with the usual operations.
 ///
-/// The class \ref lemon::dim2::Box "dim2::Box" can be used to determine
+/// The class \ref lemon::dim2::BoundingBox "dim2::BoundingBox"
+/// can be used to determine
 /// the rectangular bounding box of a set of
 /// \ref lemon::dim2::Point "dim2::Point"'s.
@@ -44,7 +46,7 @@
   /// @{
 
-  /// Two dimensional vector (plain vector)
-
-  /// A simple two dimensional vector (plain vector) implementation
+  /// A simple two dimensional vector (plainvector) implementation
+
+  /// A simple two dimensional vector (plainvector) implementation
   /// with the usual vector operations.
   template<typename T>
@@ -185,7 +187,7 @@
   }
 
-  ///Read a plain vector from a stream
-
-  ///Read a plain vector from a stream.
+  ///Read a plainvector from a stream
+
+  ///Read a plainvector from a stream.
   ///\relates Point
   ///
@@ -213,7 +215,7 @@
   }
 
-  ///Write a plain vector to a stream
-
-  ///Write a plain vector to a stream.
+  ///Write a plainvector to a stream
+
+  ///Write a plainvector to a stream.
   ///\relates Point
   ///
@@ -221,5 +223,5 @@
   inline std::ostream& operator<<(std::ostream &os, const Point<T>& z)
   {
-    os << "(" << z.x << "," << z.y << ")";
+    os << "(" << z.x << ", " << z.y << ")";
     return os;
   }
@@ -260,40 +262,37 @@
 
 
-  /// Bounding box of plain vectors (points).
-
-  /// A class to calculate or store the bounding box of plain vectors
-  /// (\ref Point "points").
-  template<typename T>
-  class Box {
-      Point<T> _bottom_left, _top_right;
+  /// A class to calculate or store the bounding box of plainvectors.
+
+  /// A class to calculate or store the bounding box of plainvectors.
+  ///
+    template<typename T>
+    class BoundingBox {
+      Point<T> bottom_left, top_right;
       bool _empty;
     public:
 
-      ///Default constructor: creates an empty box
-      Box() { _empty = true; }
-
-      ///Construct a box from one point
-      Box(Point<T> a) {
-        _bottom_left = _top_right = a;
-        _empty = false;
-      }
-
-      ///Construct a box from two points
-
-      ///Construct a box from two points.
+      ///Default constructor: creates an empty bounding box
+      BoundingBox() { _empty = true; }
+
+      ///Construct an instance from one point
+      BoundingBox(Point<T> a) { bottom_left=top_right=a; _empty = false; }
+
+      ///Construct an instance from two points
+
+      ///Construct an instance from two points.
       ///\param a The bottom left corner.
       ///\param b The top right corner.
       ///\warning The coordinates of the bottom left corner must be no more
       ///than those of the top right one.
-      Box(Point<T> a,Point<T> b)
+      BoundingBox(Point<T> a,Point<T> b)
       {
-        _bottom_left = a;
-        _top_right = b;
+        bottom_left=a;
+        top_right=b;
         _empty = false;
       }
 
-      ///Construct a box from four numbers
-
-      ///Construct a box from four numbers.
+      ///Construct an instance from four numbers
+
+      ///Construct an instance from four numbers.
       ///\param l The left side of the box.
       ///\param b The bottom of the box.
@@ -302,25 +301,25 @@
       ///\warning The left side must be no more than the right side and
       ///bottom must be no more than the top.
-      Box(T l,T b,T r,T t)
+      BoundingBox(T l,T b,T r,T t)
       {
-        _bottom_left=Point<T>(l,b);
-        _top_right=Point<T>(r,t);
+        bottom_left=Point<T>(l,b);
+        top_right=Point<T>(r,t);
         _empty = false;
       }
 
-      ///Return \c true if the box is empty.
-
-      ///Return \c true if the box is empty (i.e. return \c false
+      ///Return \c true if the bounding box is empty.
+
+      ///Return \c true if the bounding box is empty (i.e. return \c false
       ///if at least one point was added to the box or the coordinates of
       ///the box were set).
       ///
-      ///The coordinates of an empty box are not defined.
+      ///The coordinates of an empty bounding box are not defined.
       bool empty() const {
         return _empty;
       }
 
-      ///Make the box empty
+      ///Make the BoundingBox empty
       void clear() {
-        _empty = true;
+        _empty=1;
       }
 
@@ -328,7 +327,7 @@
 
       ///Give back the bottom left corner of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       Point<T> bottomLeft() const {
-        return _bottom_left;
+        return bottom_left;
       }
 
@@ -336,7 +335,7 @@
 
       ///Set the bottom left corner of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void bottomLeft(Point<T> p) {
-        _bottom_left = p;
+        bottom_left = p;
       }
 
@@ -344,7 +343,7 @@
 
       ///Give back the top right corner of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       Point<T> topRight() const {
-        return _top_right;
+        return top_right;
       }
 
@@ -352,7 +351,7 @@
 
       ///Set the top right corner of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void topRight(Point<T> p) {
-        _top_right = p;
+        top_right = p;
       }
 
@@ -360,7 +359,7 @@
 
       ///Give back the bottom right corner of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       Point<T> bottomRight() const {
-        return Point<T>(_top_right.x,_bottom_left.y);
+        return Point<T>(top_right.x,bottom_left.y);
       }
 
@@ -368,8 +367,8 @@
 
       ///Set the bottom right corner of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void bottomRight(Point<T> p) {
-        _top_right.x = p.x;
-        _bottom_left.y = p.y;
+        top_right.x = p.x;
+        bottom_left.y = p.y;
       }
 
@@ -377,7 +376,7 @@
 
       ///Give back the top left corner of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       Point<T> topLeft() const {
-        return Point<T>(_bottom_left.x,_top_right.y);
+        return Point<T>(bottom_left.x,top_right.y);
       }
 
@@ -385,8 +384,8 @@
 
       ///Set the top left corner of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void topLeft(Point<T> p) {
-        _top_right.y = p.y;
-        _bottom_left.x = p.x;
+        top_right.y = p.y;
+        bottom_left.x = p.x;
       }
 
@@ -394,7 +393,7 @@
 
       ///Give back the bottom of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T bottom() const {
-        return _bottom_left.y;
+        return bottom_left.y;
       }
 
@@ -402,7 +401,7 @@
 
       ///Set the bottom of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void bottom(T t) {
-        _bottom_left.y = t;
+        bottom_left.y = t;
       }
 
@@ -410,7 +409,7 @@
 
       ///Give back the top of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T top() const {
-        return _top_right.y;
+        return top_right.y;
       }
 
@@ -418,7 +417,7 @@
 
       ///Set the top of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void top(T t) {
-        _top_right.y = t;
+        top_right.y = t;
       }
 
@@ -426,7 +425,7 @@
 
       ///Give back the left side of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T left() const {
-        return _bottom_left.x;
+        return bottom_left.x;
       }
 
@@ -434,7 +433,7 @@
 
       ///Set the left side of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void left(T t) {
-        _bottom_left.x = t;
+        bottom_left.x = t;
       }
 
@@ -442,7 +441,7 @@
 
       /// Give back the right side of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T right() const {
-        return _top_right.x;
+        return top_right.x;
       }
 
@@ -450,7 +449,7 @@
 
       ///Set the right side of the box.
-      ///\pre The box must not be empty.
+      ///It should only be used for non-empty box.
       void right(T t) {
-        _top_right.x = t;
+        top_right.x = t;
       }
 
@@ -458,7 +457,7 @@
 
       ///Give back the height of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T height() const {
-        return _top_right.y-_bottom_left.y;
+        return top_right.y-bottom_left.y;
       }
 
@@ -466,114 +465,74 @@
 
       ///Give back the width of the box.
-      ///If the box is empty, then the return value is not defined.
+      ///If the bounding box is empty, then the return value is not defined.
       T width() const {
-        return _top_right.x-_bottom_left.x;
-      }
-
-      ///Checks whether a point is inside the box
+        return top_right.x-bottom_left.x;
+      }
+
+      ///Checks whether a point is inside a bounding box
       bool inside(const Point<T>& u) const {
         if (_empty)
           return false;
-        else {
-          return ( (u.x-_bottom_left.x)*(_top_right.x-u.x) >= 0 &&
-                   (u.y-_bottom_left.y)*(_top_right.y-u.y) >= 0 );
+        else{
+          return ((u.x-bottom_left.x)*(top_right.x-u.x) >= 0 &&
+              (u.y-bottom_left.y)*(top_right.y-u.y) >= 0 );
         }
       }
 
-      ///Increments the box with a point
-
-      ///Increments the box with a point.
+      ///Increments a bounding box with a point
+
+      ///Increments a bounding box with a point.
       ///
-      Box& add(const Point<T>& u){
-        if (_empty) {
-          _bottom_left = _top_right = u;
+      BoundingBox& add(const Point<T>& u){
+        if (_empty){
+          bottom_left=top_right=u;
           _empty = false;
         }
-        else {
-          if (_bottom_left.x > u.x) _bottom_left.x = u.x;
-          if (_bottom_left.y > u.y) _bottom_left.y = u.y;
-          if (_top_right.x < u.x) _top_right.x = u.x;
-          if (_top_right.y < u.y) _top_right.y = u.y;
+        else{
+          if (bottom_left.x > u.x) bottom_left.x = u.x;
+          if (bottom_left.y > u.y) bottom_left.y = u.y;
+          if (top_right.x < u.x) top_right.x = u.x;
+          if (top_right.y < u.y) top_right.y = u.y;
         }
         return *this;
       }
 
-      ///Increments the box to contain another box
-
-      ///Increments the box to contain another box.
+      ///Increments a bounding box to contain another bounding box
+
+      ///Increments a bounding box to contain another bounding box.
       ///
-      Box& add(const Box &u){
+      BoundingBox& add(const BoundingBox &u){
         if ( !u.empty() ){
-          add(u._bottom_left);
-          add(u._top_right);
+          this->add(u.bottomLeft());
+          this->add(u.topRight());
         }
         return *this;
       }
 
-      ///Intersection of two boxes
-
-      ///Intersection of two boxes.
+      ///Intersection of two bounding boxes
+
+      ///Intersection of two bounding boxes.
       ///
-      Box operator&(const Box& u) const {
-        Box b;
-        if (_empty || u._empty) {
+      BoundingBox operator&(const BoundingBox& u) const {
+        BoundingBox b;
+        if (this->_empty || u._empty) {
           b._empty = true;
         } else {
-          b._bottom_left.x = std::max(_bottom_left.x, u._bottom_left.x);
-          b._bottom_left.y = std::max(_bottom_left.y, u._bottom_left.y);
-          b._top_right.x = std::min(_top_right.x, u._top_right.x);
-          b._top_right.y = std::min(_top_right.y, u._top_right.y);
-          b._empty = b._bottom_left.x > b._top_right.x ||
-                     b._bottom_left.y > b._top_right.y;
+          b.bottom_left.x = std::max(this->bottom_left.x,u.bottom_left.x);
+          b.bottom_left.y = std::max(this->bottom_left.y,u.bottom_left.y);
+          b.top_right.x = std::min(this->top_right.x,u.top_right.x);
+          b.top_right.y = std::min(this->top_right.y,u.top_right.y);
+          b._empty = b.bottom_left.x > b.top_right.x ||
+                     b.bottom_left.y > b.top_right.y;
         }
         return b;
       }
 
-  };//class Box
-
-
-  ///Read a box from a stream
-
-  ///Read a box from a stream.
-  ///\relates Box
-  template<typename T>
-  inline std::istream& operator>>(std::istream &is, Box<T>& b) {
-    char c;
-    Point<T> p;
-    if (is >> c) {
-      if (c != '(') is.putback(c);
-    } else {
-      is.clear();
-    }
-    if (!(is >> p)) return is;
-    b.bottomLeft(p);
-    if (is >> c) {
-      if (c != ',') is.putback(c);
-    } else {
-      is.clear();
-    }
-    if (!(is >> p)) return is;
-    b.topRight(p);
-    if (is >> c) {
-      if (c != ')') is.putback(c);
-    } else {
-      is.clear();
-    }
-    return is;
-  }
-
-  ///Write a box to a stream
-
-  ///Write a box to a stream.
-  ///\relates Box
-  template<typename T>
-  inline std::ostream& operator<<(std::ostream &os, const Box<T>& b)
-  {
-    os << "(" << b.bottomLeft() << "," << b.topRight() << ")";
-    return os;
-  }
-
-  ///Map of x-coordinates of a <tt>Point</tt>-map
-
+    };//class Boundingbox
+
+
+  ///Map of x-coordinates of a \ref Point "Point"-map
+
+  ///\ingroup maps
   ///Map of x-coordinates of a \ref Point "Point"-map.
   ///
@@ -592,7 +551,9 @@
   };
 
-  ///Returns an XMap class
-
-  ///This function just returns an XMap class.
+  ///Returns an \ref XMap class
+
+  ///This function just returns an \ref XMap class.
+  ///
+  ///\ingroup maps
   ///\relates XMap
   template<class M>
@@ -608,7 +569,8 @@
   }
 
-  ///Constant (read only) version of XMap
-
-  ///Constant (read only) version of XMap.
+  ///Constant (read only) version of \ref XMap
+
+  ///\ingroup maps
+  ///Constant (read only) version of \ref XMap
   ///
   template<class M>
@@ -625,7 +587,9 @@
   };
 
-  ///Returns a ConstXMap class
-
-  ///This function just returns a ConstXMap class.
+  ///Returns a \ref ConstXMap class
+
+  ///This function just returns a \ref ConstXMap class.
+  ///
+  ///\ingroup maps
   ///\relates ConstXMap
   template<class M>
@@ -635,6 +599,7 @@
   }
 
-  ///Map of y-coordinates of a <tt>Point</tt>-map
-
+  ///Map of y-coordinates of a \ref Point "Point"-map
+
+  ///\ingroup maps
   ///Map of y-coordinates of a \ref Point "Point"-map.
   ///
@@ -653,7 +618,9 @@
   };
 
-  ///Returns a YMap class
-
-  ///This function just returns a YMap class.
+  ///Returns a \ref YMap class
+
+  ///This function just returns a \ref YMap class.
+  ///
+  ///\ingroup maps
   ///\relates YMap
   template<class M>
@@ -669,7 +636,8 @@
   }
 
-  ///Constant (read only) version of YMap
-
-  ///Constant (read only) version of YMap.
+  ///Constant (read only) version of \ref YMap
+
+  ///\ingroup maps
+  ///Constant (read only) version of \ref YMap
   ///
   template<class M>
@@ -686,7 +654,9 @@
   };
 
-  ///Returns a ConstYMap class
-
-  ///This function just returns a ConstYMap class.
+  ///Returns a \ref ConstYMap class
+
+  ///This function just returns a \ref ConstYMap class.
+  ///
+  ///\ingroup maps
   ///\relates ConstYMap
   template<class M>
@@ -697,8 +667,10 @@
 
 
-  ///\brief Map of the normSquare() of a <tt>Point</tt>-map
+  ///\brief Map of the \ref Point::normSquare() "normSquare()"
+  ///of a \ref Point "Point"-map
   ///
   ///Map of the \ref Point::normSquare() "normSquare()"
   ///of a \ref Point "Point"-map.
+  ///\ingroup maps
   template<class M>
   class NormSquareMap
@@ -714,7 +686,9 @@
   };
 
-  ///Returns a NormSquareMap class
-
-  ///This function just returns a NormSquareMap class.
+  ///Returns a \ref NormSquareMap class
+
+  ///This function just returns a \ref NormSquareMap class.
+  ///
+  ///\ingroup maps
   ///\relates NormSquareMap
   template<class M>
